import "antd/es/form/style";
import _Form from "antd/es/form";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import { InternalType } from './interface';
import ComposeField from './compose-field';
import BaseField from './base-field';
import ListField from './list-field';
import { registerFieldType } from './components';
import { getKeyByNamePath } from './utils';

var SchemaForm = function SchemaForm(_ref) {
  var _ref$fieldItems = _ref.fieldItems,
      fieldItems = _ref$fieldItems === void 0 ? [] : _ref$fieldItems,
      restProps = _objectWithoutProperties(_ref, ["fieldItems"]);

  return /*#__PURE__*/React.createElement(_Form, restProps, fieldItems.map(function (item, index) {
    if (item.type === InternalType.Compose) {
      return /*#__PURE__*/React.createElement(ComposeField, _extends({
        key: index
      }, item));
    } else if (item.type === InternalType.List) {
      return /*#__PURE__*/React.createElement(ListField, _extends({
        key: index
      }, item));
    } else {
      return /*#__PURE__*/React.createElement(BaseField, _extends({
        key: getKeyByNamePath(item.name || index)
      }, item));
    }
  }));
};

SchemaForm.registerFieldType = registerFieldType;
SchemaForm.Compose = InternalType.Compose;
SchemaForm.List = InternalType.List;
export default SchemaForm;