import "antd/es/form/style";
import _Form from "antd/es/form";
import "antd/es/row/style";
import _Row from "antd/es/row";
import "antd/es/space/style";
import _Space from "antd/es/space";
import "antd/es/button/style";
import _Button from "antd/es/button";
import "antd/es/col/style";
import _Col from "antd/es/col";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React, { useCallback } from 'react';
import { InternalType } from './interface';
import BaseField from './base-field';
import { isNil } from './utils';
import ComposeField from './compose-field';
import { MinusOutlined, ArrowUpOutlined, ArrowDownOutlined } from '@ant-design/icons';

var ListFieldInner = function ListFieldInner(_ref) {
  var operations = _ref.operations,
      index = _ref.index,
      moveable = _ref.moveable,
      removable = _ref.removable,
      children = _ref.children,
      moveButtonProps = _ref.moveButtonProps,
      removeButtonProps = _ref.removeButtonProps,
      _ref$isLast = _ref.isLast,
      isLast = _ref$isLast === void 0 ? false : _ref$isLast;
  var handleRemove = useCallback(function () {
    operations.remove(index);
  }, [operations, index]);
  var handleMoveUp = useCallback(function () {
    operations.move(index, index - 1);
  }, [operations, index]);
  var handleMoveDown = useCallback(function () {
    operations.move(index, index + 1);
  }, [operations, index]);
  return /*#__PURE__*/React.createElement(_Row, {
    gutter: 12,
    style: {
      alignItems: 'baseline'
    }
  }, /*#__PURE__*/React.createElement(_Col, {
    style: {
      flex: 1
    },
    key: "field"
  }, children), removable || moveable ? /*#__PURE__*/React.createElement(_Col, {
    style: {
      width: 100
    },
    key: "operations"
  }, /*#__PURE__*/React.createElement(_Space, {
    size: "small"
  }, removable ? /*#__PURE__*/React.createElement(_Button, _extends({
    size: "small",
    type: "link",
    onClick: handleRemove,
    title: "\u79FB\u9664",
    icon: /*#__PURE__*/React.createElement(MinusOutlined, null)
  }, removeButtonProps)) : null, index > 0 && moveable ? /*#__PURE__*/React.createElement(_Button, _extends({
    size: "small",
    type: "link",
    onClick: handleMoveUp,
    title: "\u4E0A\u79FB",
    icon: /*#__PURE__*/React.createElement(ArrowUpOutlined, null)
  }, moveButtonProps)) : null, !isLast && moveable ? /*#__PURE__*/React.createElement(_Button, _extends({
    size: "small",
    type: "link",
    onClick: handleMoveDown,
    title: "\u4E0B\u79FB",
    icon: /*#__PURE__*/React.createElement(ArrowDownOutlined, null)
  }, moveButtonProps)) : null)) : null);
};

var ListField = function ListField(_ref2) {
  var field = _ref2.field,
      type = _ref2.type,
      label = _ref2.label,
      _ref2$addable = _ref2.addable,
      addable = _ref2$addable === void 0 ? true : _ref2$addable,
      _ref2$moveable = _ref2.moveable,
      moveable = _ref2$moveable === void 0 ? true : _ref2$moveable,
      _ref2$removable = _ref2.removable,
      removable = _ref2$removable === void 0 ? true : _ref2$removable,
      addRender = _ref2.addRender,
      defaultValue = _ref2.defaultValue,
      addButtonProps = _ref2.addButtonProps,
      moveButtonProps = _ref2.moveButtonProps,
      removeButtonProps = _ref2.removeButtonProps,
      restProps = _objectWithoutProperties(_ref2, ["field", "type", "label", "addable", "moveable", "removable", "addRender", "defaultValue", "addButtonProps", "moveButtonProps", "removeButtonProps"]);

  var fieldRender = useCallback(function (_ref3) {
    var listField = _ref3.listField,
        operations = _ref3.operations,
        index = _ref3.index,
        fields = _ref3.fields;

    if (field.type === InternalType.Compose) {
      return /*#__PURE__*/React.createElement(ListFieldInner, {
        key: listField.key,
        operations: operations,
        index: index,
        moveable: moveable,
        removable: removable,
        isLast: index === fields.length - 1,
        moveButtonProps: moveButtonProps,
        removeButtonProps: removeButtonProps
      }, /*#__PURE__*/React.createElement(ComposeField, _extends({}, field, {
        fields: field.fields.map(function (item) {
          var name = [listField.name, item.name].filter(function (name) {
            return !isNil(name);
          });
          return _objectSpread(_objectSpread({}, item), {}, {
            name: name
          });
        })
      })));
    } else {
      var name = [listField.name, field.name].filter(function (name) {
        return !isNil(name);
      });
      return /*#__PURE__*/React.createElement(ListFieldInner, {
        key: listField.key,
        operations: operations,
        index: index,
        moveable: moveable,
        removable: removable,
        isLast: index === fields.length - 1,
        moveButtonProps: moveButtonProps,
        removeButtonProps: removeButtonProps
      }, /*#__PURE__*/React.createElement(BaseField, _extends({}, listField, field, {
        name: name,
        label: undefined
      })));
    }
  }, [field, moveable, removable, moveButtonProps, removeButtonProps]);
  return /*#__PURE__*/React.createElement(_Form.Item, {
    label: label
  }, /*#__PURE__*/React.createElement(_Form.List, restProps, function (fields, operations) {
    var handleAdd = function handleAdd() {
      if (typeof defaultValue === 'function') {
        operations.add(defaultValue(fields));
      } else {
        operations.add(defaultValue);
      }
    };

    return /*#__PURE__*/React.createElement("div", null, fields.map(function (listField, index) {
      return fieldRender({
        listField: listField,
        operations: operations,
        fields: fields,
        index: index
      });
    }), addable ? addRender ? addRender(operations.add) : /*#__PURE__*/React.createElement(_Button, _extends({
      block: true,
      type: "dashed",
      children: "\u65B0\u589E"
    }, addButtonProps, {
      onClick: handleAdd
    })) : null);
  }));
};

export default ListField;