"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("antd/lib/form/style");

var _form = _interopRequireDefault(require("antd/lib/form"));

var _react = _interopRequireDefault(require("react"));

var _interface = require("./interface");

var _composeField = _interopRequireDefault(require("./compose-field"));

var _baseField = _interopRequireDefault(require("./base-field"));

var _listField = _interopRequireDefault(require("./list-field"));

var _components = require("./components");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var SchemaForm = function SchemaForm(_ref) {
  var _ref$fieldItems = _ref.fieldItems,
      fieldItems = _ref$fieldItems === void 0 ? [] : _ref$fieldItems,
      restProps = _objectWithoutProperties(_ref, ["fieldItems"]);

  return /*#__PURE__*/_react.default.createElement(_form.default, restProps, fieldItems.map(function (item, index) {
    if (item.type === _interface.InternalType.Compose) {
      return /*#__PURE__*/_react.default.createElement(_composeField.default, _extends({
        key: index
      }, item));
    } else if (item.type === _interface.InternalType.List) {
      return /*#__PURE__*/_react.default.createElement(_listField.default, _extends({
        key: index
      }, item));
    } else {
      return /*#__PURE__*/_react.default.createElement(_baseField.default, _extends({
        key: (0, _utils.getKeyByNamePath)(item.name || index)
      }, item));
    }
  }));
};

SchemaForm.registerFieldType = _components.registerFieldType;
SchemaForm.Compose = _interface.InternalType.Compose;
SchemaForm.List = _interface.InternalType.List;
var _default = SchemaForm;
exports.default = _default;